<?php

namespace App\Helper;
use App\Vendor\BBCode\BBCode as Parser;

//use ChrisKonnertz\BBCode\BBCode as Parser;

class BBCode {

    private $parser;
    private $content;

    public function __construct($content)
    {
        $this->parser = new Parser();
        $this->content = $content;
        //$this->defineTags();
    }

    private function defineTags()
    {
        // bold
        $this->parser->addTag('b', function($tag, &$html, $openingTag) {
            return $openingTag ? '<strong>' : '</strong>';
        });

        // italics
        $this->parser->addTag('i', function($tag, &$html, $openingTag) {
            return $openingTag ? '<em>' : '</em>';
        });

        // underline
        $this->parser->addTag('u', function($tag, &$html, $openingTag) {
            return $openingTag ? '<u>' : '</u>';
        });

        // strikethrough
        $this->parser->addTag('s', function($tag, &$html, $openingTag) {
            return $openingTag ? '<s>' : '</s>';
        });

        // spoiler
        $this->parser->addTag('spoiler', function($tag, &$html, $openingTag) {
            return $openingTag ? '<span class="spoiler">' : '</span>';
        });

        // heading 1
        $this->parser->addTag('h1', function($tag, &$html, $openingTag) {
            return $openingTag ? '<h1>' : '</h1>';
        });

        // heading 2
        $this->parser->addTag('h2', function($tag, &$html, $openingTag) {
            return $openingTag ? '<h2>' : '</h2>';
        });

        // hyperlink
        $this->parser->addTag('url', function($tag, &$html, $openingTag) {
            if (!$openingTag) return '</a>';
            return sprintf('<a href="%s">', $tag->property ?? $html);
        });

        // blockquote
        $this->parser->addTag('blockquote', function($tag, &$html, $openingTag) {
            return $openingTag ? '<div class="blockquote">' : '</div>';
        });

        // code
        $this->parser->addTag('code', function($tag, &$html, $openingTag) {
            return $openingTag ? '<pre>' : '</pre>';
        });

        // unordered list
        $this->parser->addTag('ul', function($tag, &$html, $openingTag) {
            return $openingTag ? '<ul>' : '</ul>';
        });

        // ordered list
        $this->parser->addTag('ol', function($tag, &$html, $openingTag) {
            return $openingTag ? '<ol>' : '</ol>';
        });

        // list item
        $this->parser->addTag('li', function($tag, &$html, $openingTag) {
            return $openingTag ? '<li>' : '</li>';
        });

        // quote
        $this->parser->addTag('quote', function($tag, &$html, $openingTag) {
            return $this->renderQuote($tag, $html, $openingTag);
        });

        // quote shorthand
        $this->parser->addTag('q', function($tag, &$html, $openingTag) {
            return $this->renderQuote($tag, $html, $openingTag);
        });

    }

    public function renderQuote($tag, &$html, $openingTag)
    {
        exit('kek');
        if (!$openingTag) return '</div></div>';
        return '<div class="quote"><a class="user" href="#">User</a><div class="postContent">';
        // '<div class="quote"><a class="user" href="/thread/%d/%d#post-%d">%s</a><div class="postContent">',
        //                         $postData->threadId,
        //                         $postData->threadPage,
        //                         $postData->postId,
        //                         $postData->username
    }

    public function render()
    {
        //$test = '[quote mentionsUser="1427" postId="659032" threadPage="1" threadId="19764" username="Dr. Magnusson"][/quote]';
        return $this->parser->renderPlain($this->content);
    }

}
