<?php

namespace App\Knockout;

use App\Helper\BBCode;
use Carbon\Carbon;

class Post {

    // meta
    public $id;
    public $date;
    public $content;

    // related
    public User $user;

    public static function unwrap($post)
    {
        $s = new self();

        $s->id              = $post->id;
        $s->date            = Carbon::parse($post->createdAt)->format('d/m/Y H:i');
        $s->content         = $post->content;

        // grab user if available
        if (isset($post->user)) {
            $s->user = User::unwrap($post->user);
        }

        return $s;
    }

    public function dateDiff()
    {
        return Carbon::createFromFormat('d/m/Y H:i', $this->date)->diffForHumans();
    }

    public function render()
    {
        return (new BBCode($this->content))->render();
    }

}
